;-------------------------------------------;
; CASOVANI POMOCI TMR0 S PREDDELICKOU 1:256 ;
;       !!! NUTNO POUZIT DISPLEJ !!!        ;
;-------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'


	#include	displej.inc
	#include	tab_util.inc
	#include	dskripty.inc
	#include	div16u.inc

;---------------------------------------------
; KONSTANTY PROGRAMU

STRFREK EQU	D'5000000' ; pocet strojovych taktu za sekundu

KONST	EQU	STRFREK / H'10000'
KONSTCH	EQU	STRFREK % H'10000'

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"
TEMPRAM	EQU	H'70'	; posledni blok pameti (16 bytu)
			; - je zrcadlen do vsech pametovych bank

	CBLOCK	OFFRAM
	TML:1
	TMH:1
	DDATA:1

	CLOCK:1	; pro mereni casu
	ODCHYLKA:2
	TIK:1
	SEC:1
	MIN:1
	HOD:1

	AA:2	; pro skripty
	BB:2
	CC:2
	VD16U:1
	NUMFORM_:1
	ENDC

	CBLOCK	TEMPRAM	; zalozni registry, ktere
	W_TEMP:1		; jsou nezavisle na zvolene
	ST_TEMP:1		; pametove bance !!!
	ENDC

;------------------------------------------------------
; RESET / START
	
	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	GOTO	START

;------------------------------------------------------
; OBSLUHA PRERUSENI

	ORG	4
	MOVWF	W_TEMP	; zaloha registru W a STATUS
	MOVF	STATUS,W
	MOVWF	ST_TEMP
	banksel	0
	BCF	INTCON,T0IF	; odstraneni priznaku
	DECFSZ	CLOCK,F		; postupna dekrementace 8bitove promenne CLOCK
	GOTO	INT_END
	MOVLW	KONST		; je-li vysledek dekrementace nula,...
	MOVWF	CLOCK		; ...potom nastavime CLOCK na prislusnou hodnotu
	INCF	TIK,F		; ubehla dalsi sekunda
	MOVLW	KONSTCH % H'100'	; upravujeme 16bitovy citac odchylky
	ADDWF	ODCHYLKA+0,F
	MOVLW	KONSTCH / H'100'
	IF (KONSTCH / H'100')==D'255'	; pomocna konstrukce, za ucelem...
	BTFSS	STATUS,C		; ...optimalniho 16bitoveho pricitani...
	ADDWF	ODCHYLKA+1,F	; ...konstanty do promenne
	ELSE
	BTFSC	STATUS,C
	MOVLW	KONSTCH / H'100' + 1
	ADDWF	ODCHYLKA + 1,F
	ENDIF
	BTFSC	STATUS,C		; pokud odchylka pretekla,...
	INCF	CLOCK,F		; ...musime zvysit CLOCK
INT_END	MOVF	ST_TEMP,W		; obnova registru ze zalohy
	MOVWF	STATUS
	SWAPF	W_TEMP,F
	SWAPF	W_TEMP,W
	RETFIE

;-------------------------------------------------
; INICIALIZACE
START	
	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1

	banksel	OPTION_REG
	MOVLW	B'11010111'
	MOVWF	OPTION_REG
	banksel	TMR0
	CLRF	TMR0
	BCF	INTCON,T0IF

	CALL	INITDISP	; inicializace displeje

	MOVLW	KONST	; pocatecni nastaveni promennych
	MOVWF	CLOCK
	CLRF	ODCHYLKA+0
	CLRF	ODCHYLKA+1
	CLRF	TIK
	CLRF	SEC
	CLRF	MIN
	CLRF	HOD

	BSF	INTCON,T0IE	; povoleno preruseni od TMR0
	BSF	INTCON,GIE	; aktivace systemu preruseni

;----------------------------------------------------
; HLAVNI PROGRAM

	MOVLW	D'0'
	CALL	SKRIPT
LOOP	MOVF	TIK,W	; testujeme, zda doslo ke zvyseni citace sekund
	BTFSC	STATUS,Z
	GOTO	LOOP
	DECF	TIK,F	; pokud ano snizime citac sekund a...
	CALL	INC_TIME	; ...inkrementujeme casomiru
	MOVLW	D'0'	; zobrazime cas na displeji
	CALL	SKRIPT
	GOTO	LOOP

INC_TIME	INCF	SEC,F	; zvysime sekundovou cislici
	MOVF	SEC,W
	XORLW	D'60'
	BTFSS	STATUS,Z	; pokud dosahne hodnoty 60,...
	RETURN
	CLRF	SEC	; ...vynulujeme ji a....
	INCF	MIN,F	; ...zvysime cislici minut
	MOVF	MIN,W
	XORLW	D'60'
	BTFSS	STATUS,Z	; obdobne to vyresime i pro cislici hodin
	RETURN
	CLRF	MIN
	INCF	HOD,F
	MOVF	HOD,W
	XORLW	D'24'
	BTFSS	STATUS,Z
	RETURN
	CLRF	HOD
	RETURN

;-------------------------------------------------------------
;deleni
DIV16U	DIV16U_M	AA,BB,CC,VD16U 

; zobrazovaci skripty
SKRIPT	SKRIPT_	TABULKY, PUTZNAK, DPRIKAZ, NUMFORM_, DIV16U, AA, BB, CC
	RETURN

; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS
;-------------------------------------------------------------

TABULKY	DATA	VYPIS_CLK

; vypise na displeji napis "CASOMIRA (2)" a...
; ...cas ve formatu HH:MM:SS
VYPIS_CLK	POS_D	D'0'
	DE	"  CASOMIRA (2)  "
	POS_D	D'64'
	DE	"    "
	PRINTV	HOD,B'00011',0,0,1,1
	DE	":"
	PRINTV	MIN,B'00011',0,0,1,1
	DE	":"
	PRINTV	SEC,B'00011',0,0,1,1
	DE	"    "
	EOFS

	END
