;--------------------------------------------------;
; TENTO PROGRAM MERI ZPOZDENI, VZNIKLE PROBUZENIM  ;
; MIKROKONTROLERU Z REZIMU SLEEP                   ;
; !!! NUTNO POUZIT DISPLEJ A SEKUND. OSCILATOR !!! ;
;--------------------------------------------------;

	LIST	P = 16F877, R = DEC
	#include	p16f877.inc

	__CONFIG	B'11111100111010'


	#include	displej.inc
	#include	tab_util.inc
	#include	dskripty.inc
	#include	div16u.inc

;---------------------------------------------
; KONSTANTY PROGRAMU

#DEFINE	DB4	PORTE,2	; piny pro ovladani displeje
#DEFINE	DB5	PORTE,1
#DEFINE	DB6	PORTE,0
#DEFINE	DB7	PORTA,4
#DEFINE	E	PORTB,1
#DEFINE	RW	PORTB,2
#DEFINE	RS	PORTB,3

OFFRAM	EQU	H'20'	; zacatek volne pameti "RAM"

	CBLOCK	OFFRAM
	TML:1
	TMH:1
	DDATA:1

	DELAY:1	; pro mereni zpozdeni

	AA:2	; pro skripty
	BB:2
	CC:2
	VD16U:1
	NUMFORM_:1
	ENDC

;------------------------------------------------------
; RESET / START
	
	ORG	0
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI
	NOP	; kvuli ZAVADECI

	banksel	ADCON1
	MOVLW	B'00000110'	; nastav PORTA a PORTE jako "logicky"
	MOVWF	ADCON1

	banksel	OPTION_REG
	MOVLW	B'00001000'
	MOVWF	OPTION_REG

	banksel	T1CON	; nastaveni casovace TMR1
	MOVLW	B'00001111'
	MOVWF	T1CON
	banksel	0

	CALL	INITDISP	; inicializace displeje

	banksel	PIE1
	BSF	PIE1,TMR1IE ; nastaveni zdroje preruseni - TMR1
	banksel	0
	BSF	INTCON,PEIE ; povoleni zdroje preruseni z PIR1 a PIR2

	CLRF	TMR1L	; nastaveni TMR1 tak, aby doslo k preteceni za 1 sekundu
	MOVLW	D'128'
	MOVWF	TMR1H
	BCF	PIR1,TMR1IF

;----------------------------------------------------
; HLAVNI PROGRAM

	SLEEP	; prechod do rezimu SLEEP
LOOP	BTFSS	PIR1,TMR1IF	; cekani na preteceni TMR1
	GOTO	LOOP
	MOVF	TMR1L,W		; precteme nizsi byte TMR1...
	MOVWF	DELAY		; ...a ulozime jej do pomocne promenne DELAY
	BCF	PIR1,TMR1IF	; odstranime priznak preteceni
	BSF	TMR1H,7		; nastavime periodu TMR1 na 1 sekundu
	MOVLW	D'0'		; zobrazime stav promenne DELAY
	CALL	SKRIPT
	SLEEP			; prechod do rezimu SLEEP
	GOTO	LOOP

;------------------------------------------------
; deleni
DIV16U	DIV16U_M	AA,BB,CC,VD16U 

; zobrazovaci skripty
SKRIPT	SKRIPT_	TABULKY, PUTZNAK, DPRIKAZ, NUMFORM_, DIV16U, AA, BB, CC
	RETURN

; obsluha displeje
	DISPLEJ	TMH,TML,DDATA,DB4,DB5,DB6,DB7,E,RW,RS

;-------------------------------------------------------------
TABULKY	DATA	VYPIS

; vypise na displeji napis "zpozd.probuzeni:" a...
; ...hodnotu DELAY (triciferne) s dodatkem "z TMR1"
VYPIS	POS_D	D'0'
	DE	"zpozd.probuzeni:"
	POS_D	D'64'
	DE	"   "
	PRINTV	DELAY,B'00111',0,0,1,1
	DE	" z TMR1   "
	EOFS

	END

